package mysql

import (
	"context"
	"fmt"
	"pji_desktop_http/biz/dal/query"
	"pji_desktop_http/biz/model"
)

func AddMapUpdateOneRecord(ctx context.Context, record model.MapUpdate) error {
	r := query.MapUpdate
	err := r.WithContext(ctx).Create(&record)
	return err
}

func QueryMapUpdateRecords(ctx context.Context, record *model.MapUpdate, pageFlag bool, page, pageSize int) ([]*model.MapUpdate, int64, error) {
	r := query.MapUpdate
	q := r.WithContext(ctx)
	var records []*model.MapUpdate
	var count int64
	var err error
	if record.DeviceName != "" {
		q = q.Where(r.DeviceName.Like("%" + record.DeviceName + "%"))
	}
	if record.DeviceType != "" {
		q = q.Where(r.DeviceType.Eq(record.DeviceType))
	}

	if pageFlag {
		offset := (page - 1) * pageSize
		records, count, err = q.Order(r.UpdateTime.Desc()).FindByPage(offset, pageSize)
	} else {
		records, err = q.Order(r.UpdateTime.Desc()).Find()
	}

	if err != nil {
		fmt.Println("Query simulation records failed:", err.Error())
		return nil, 0, err
	}

	fmt.Println("Query simulation records successfully:", len(records))
	return records, count, err
}
